// C Source File
// Created 2/22/02; 4:04:15 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#include <tigcclib.h>         // Include All Header Files
#include <extgraph.h>
#include "utility.h"
#include "select.h"

unsigned char hand[192] = {
	//sprite 0
	0x04,0x00,0x0a,0x00,0x19,0x00,0x19,0x00,0x19,0xc0,0x19,0xb0,0x2a,0x88,0x59,0xc4,0x41,0xc4,0x51,0xc4,0x61,0xc4,0x2b,0xc4,0x1b,0x88,0x05,0x10,0x08,0x48,0x07,0xf0,
	0x04,0x00,0x0e,0x00,0x13,0x00,0x13,0x00,0x13,0xc0,0x13,0x70,0x31,0x78,0x70,0x3c,0x50,0x3c,0x40,0x3c,0x40,0x3c,0x30,0x3c,0x1c,0x78,0x06,0xf0,0x0c,0x38,0x07,0xf0,
	0xfb,0xff,0xf1,0xff,0xe0,0xff,0xe0,0xff,0xe0,0x3f,0xe0,0x0f,0xc0,0x07,0x80,0x03,0x80,0x03,0x80,0x03,0x80,0x03,0xc0,0x03,0xe0,0x07,0xf8,0x0f,0xf0,0x07,0xf8,0x0f,
	//sprite 1
	0x00,0x00,0x07,0x80,0x0c,0x40,0x12,0xbc,0x58,0xfe,0xa0,0x01,0x98,0x42,0xbf,0xbc,0x9f,0xf0,0xcf,0x90,0x80,0x20,0xa0,0x20,0x50,0x40,0x0f,0x80,0x00,0x00,0x00,0x00,
	0x00,0x00,0x07,0x80,0x08,0xc0,0x19,0xfc,0x50,0x02,0xf0,0x03,0xa0,0x3e,0x80,0x7c,0xa0,0x10,0xb0,0x70,0xff,0xe0,0xff,0xe0,0x5f,0xc0,0x0f,0x80,0x00,0x00,0x00,0x00,
	0xff,0xff,0xf8,0x7f,0xf0,0x3f,0xe0,0x03,0xa0,0x01,0x00,0x00,0x00,0x01,0x00,0x03,0x00,0x0f,0x00,0x0f,0x00,0x1f,0x00,0x1f,0xa0,0x3f,0xf0,0x7f,0xff,0xff,0xff,0xff,
};

void menu_init(MENU *menu, int x, int y, int x_space, int y_space, int max)
{
	memset(menu, 0, sizeof(MENU));
	
	menu->x = x;
	menu->y = y;
	menu->x_space = x_space;
	menu->y_space = y_space;
	menu->max = max;
	menu->hand_x = x;
	menu->hand_y = y;
}

void menu_process(MENU *menu)
{
	int k;
	
	if(menu->hand_distance) {
		menu->hand_x_counter += (menu->x_space * 20);
		menu->hand_y_counter += (menu->y_space * 20);
	
		while(menu->hand_x_counter >= 100) {
			menu->hand_x += menu->hand_direction;
			menu->hand_x_counter -= 100;
		}
		
		while(menu->hand_y_counter >= 100) {
			menu->hand_y += menu->hand_direction;
			menu->hand_y_counter -= 100;
		}
		
		menu->hand_distance--;
		return;
	}
	
	k = _rowread(ARROWS_ROW);
	
	if(((k & LEFT_KEY) && menu->x_space > menu->y_space) ||
		 ((k & UP_KEY) && menu->y_space > menu->x_space)) {
				menu->select--;
				menu->hand_direction = -1;
				menu->hand_distance = 5;
	} else if(((k & RIGHT_KEY) && menu->x_space > menu->y_space) ||
		 ((k & DOWN_KEY) && menu->y_space > menu->x_space)) {
				menu->select++;
				menu->hand_direction = 1;
				menu->hand_distance = 5;
	}
	
	if(menu->select < 0) {
		menu->select = menu->max - 1;
		menu->hand_x = menu->x + menu->x_space * (menu->max - 1);
		menu->hand_y = menu->y + menu->y_space * (menu->max - 1);
		menu->hand_direction = 0;
		menu->hand_distance = 0;
	}
	
	if(menu->select == menu->max) {
		menu->select = 0;
		menu->hand_x = menu->x;
		menu->hand_y = menu->y;
		menu->hand_direction = 0;
		menu->hand_distance = 0;
	}
}

void menu_draw(MENU *menu)
{
	if(menu->x_space > menu->y_space)
		GraySprite16_MASK(menu->hand_x + x_buffer, menu->hand_y + y_buffer, 16,
			(unsigned short *)(hand), (unsigned short *)(hand + 32),
			(unsigned short *)(hand + 64), (unsigned short *)(hand + 64),
			light_buffer, dark_buffer);
	else
		GraySprite16_MASK(menu->hand_x + x_buffer, menu->hand_y + y_buffer, 16,
			(unsigned short *)(hand + 96), (unsigned short *)(hand + 96 + 32),
			(unsigned short *)(hand + 96 + 64), (unsigned short *)(hand + 96 + 64),
			light_buffer, dark_buffer);
}
