// C Header File
// Created 1/8/02; 10:56:38 PM

#ifndef __TILES__
#define __TILES__

#include "player.h"
#include "dllexports.h"

typedef struct {
	unsigned char hit;
	unsigned char blit;
	unsigned short data[36];
} TILE_DATA;

typedef struct {
	short x;
	short y;
	short counter;
	char type;

	short next;
} HOLE;

enum {
	EMPTY,
	//BACKGROUND,
	WAYPOINT,
	SPIKES,
	SOLID,

	BREAK_STAND_REFORM,
	BREAK_STAND_LEFT_REFORM,
	BREAK_STAND_MIDDLE_HORIZ_REFORM,
	BREAK_STAND_RIGHT_REFORM,
	BREAK_STAND_UP_REFORM,
	BREAK_STAND_MIDDLE_VERT_REFORM,
	BREAK_STAND_DOWN_REFORM,
	BREAK_STAND_UL_CORNER_REFORM,
	BREAK_STAND_UR_CORNER_REFORM,
	BREAK_STAND_BL_CORNER_REFORM,
	BREAK_STAND_BR_CORNER_REFORM,
	BREAK_STAND_CHAIN_REFORM,

	BREAK_STAND,
	BREAK_STAND_LEFT,
	BREAK_STAND_MIDDLE_HORIZ,
	BREAK_STAND_RIGHT,
	BREAK_STAND_UP,
	BREAK_STAND_MIDDLE_VERT,
	BREAK_STAND_DOWN,
	BREAK_STAND_UL_CORNER,
	BREAK_STAND_UR_CORNER,
	BREAK_STAND_BL_CORNER,
	BREAK_STAND_BR_CORNER,
	BREAK_STAND_CHAIN,

	BREAK_SHOOT,
	BREAK_SHOOT_LEFT,
	BREAK_SHOOT_MIDDLE_HORIZ,
	BREAK_SHOOT_RIGHT,
	BREAK_SHOOT_UP,
	BREAK_SHOOT_MIDDLE_VERT,
	BREAK_SHOOT_DOWN,
	BREAK_SHOOT_UL_CORNER,
	BREAK_SHOOT_UR_CORNER,
	BREAK_SHOOT_BL_CORNER,
	BREAK_SHOOT_BR_CORNER,
	BREAK_SHOOT_CHAIN,

	BREAK_BOMB,
	BREAK_BOMB_LEFT,
	BREAK_BOMB_MIDDLE_HORIZ,
	BREAK_BOMB_RIGHT,
	BREAK_BOMB_UP,
	BREAK_BOMB_MIDDLE_VERT,
	BREAK_BOMB_DOWN,
	BREAK_BOMB_UL_CORNER,
	BREAK_BOMB_UR_CORNER,
	BREAK_BOMB_BL_CORNER,
	BREAK_BOMB_BR_CORNER,
	BREAK_BOMB_CHAIN,

	BREAK_SPEED_REFORM,
	BREAK_SUPERMISSILE,
	BREAK_POWERBOMB,
	BREAK_SCREW,
	BREAK_SPEED,
	BREAK_ENEMY,

	BREAK_SHOOT_BOMB_SWITCH,

	//BACKGROUND_SOLID,
	SLOPE_RIGHT_UP,
	SLOPE_LEFT_UP,
	SLOPE_RIGHT_DOWN,
	SLOPE_LEFT_DOWN,
};

#define HOLE_MAX 40

#ifndef __IN_DLL__
//#define tile_data _DLL_glbvar(TILE_DATA *, DLL_TILE_DATA)
#define tile_setup _DLL_call(char, (), TILE_SETUP)
#define tile_cleanup _DLL_call(void, (), TILE_CLEANUP)
#define tileset_load _DLL_call(char, (short, char), TILESET_LOAD)
#define hole_enemy_check _DLL_call(void, (), HOLE_ENEMY_CHECK)
#define hole_reset _DLL_call(void, (), HOLE_RESET)
#define hole_create _DLL_call(char, (short, short, unsigned short), HOLE_CREATE)
#define hole_process _DLL_call(void, (), HOLE_PROCESS)
#endif

#endif

